# <b># MagicPlugin</b>

Adds 11 new early game magic weapons, 10 armors with set effect, 5 eitr foods that is centered on the useless yellow mushroom, 7 new summonable creatures and 6 magical belts.
<br/>

![](https://i.ibb.co/dKDfpgK/newss01.png)
![](https://i.ibb.co/343GrSb/front01.png)
![](https://i.ibb.co/JFYy03x/front02.png)
![](https://i.ibb.co/5xxv5zC/front03.png)
![](https://i.ibb.co/LSfGChr/front04.png)
[![Watch the video](https://i.imgur.com/vKb2F1B.png)](https://www.youtube.com/watch?v=g-Okgy7TPwo)

<br/>

>## ## Installation (manual)

- extract `MagicPlugin.dll` file to your `BepInEx\Plugins\` folder.


</br>

>## ## Features

- Configurable velocity and accuracy.
- Configurable exp multipliers for elemental magic and blood magic.
- Adds 3 new early game Magic Weapon called Surtling Staff, Eikthyrs Staff and Neck Totem and 5 new mid game Magic Weapon called Staff of Healing, Wolf Totem, Arctic Staff, Crystal Totem and Poison Staff.
- Adds 2 new armors with set effect called Black Forest Eitr-Hood and Black Forest Eitr-Cape which increases your eitr regen by 10%.
- Adds 4 new armors with set effect called Polarwolf Hood, Polarwolf Tunic, Polarwolf Trouser, and Cultist Cape which gives cold and freezing resist and increases your eitr regen by 25%.
- Adds 4 new armors with eitr regen per piece called Red Wizard Hood with poison resist, Red Wizard Sleeves with fire resist, Red Wizard Trouser, and Red Wizard Cape with frost resist and feather fall.
- Adds 3 new Eitr Foods that is centered on the useless yellow mushroom called Mushroom Jam, Sauted Meat 'N Mushroom and Mushroom Pie which will give you a total of 76 Eitr. Now you have another reason to go Burial Chamber hunting besides farming surtling cores.
- Adds 2 new Eitr Foods called Mountain Soup and Mountain Stew together with Mushroom Pie will give you a total of 124 Eitr whis is the prerequisite in using the Wolf Totem.
- Adds 6 new magical belts that will help you on your magical journey called Dvergrs Belt, Wizards Belt, Elementalist Belt, Hogwarts Belt, Haldors Belt, and Necromancers Belt.
- Configurable cooldown timer, chop/pickaxe damage, fire/lightning/frost damage, blunt/pierce damage and attack force.
- Configurable magic source, you can use either Eitr, Stamina or Both.
- Configurable Eitr regen amount.
- Configurable food stats.
- Configurable summons health and attack damages.
- Configurable Heal Overtime, Heal duration, Heal interval, Heal cooldown, and Heal range.
- You can now heal yourself, your summon, your tames/pet and supposedly other chars if you have Groups by smoothbrain installed.
- Uses ServerSync and built in config watcher.
- Configurable through config file or [Configuration Manager](https://valheim.thunderstore.io/package/Azumatt/Official_BepInEx_ConfigurationManager/)

>** Surtling Staff (Elemental Magic)(Fire Damage)
- Can be used to demolish a whole forest.
- Tool tier is determined by its quality level.
- Level 1 for Beech Trees, Level 2 for Birch Trees and so on. 
- Configurable Base Tree Damage which is scaled by your woodcutting skill level for more damage to trees.
- AOE Range is scaled by your elemental magic skill level.
- The higher your elemental magic skill level the wider the AOE.
- You can get a small fraction of exp for woodcutting skill when hitting trees with the staff.
- And you can get elemental magic exp for killing monsters or wild animals.

>** Eikthyrs Staff (Elemental Magic)(Lightning Damage)
- Can be used to demolish rocks and minerals.
- Tool tier is determined by its quality level.
- AOE Range is scaled by your elemental magic skill level.
- You can get a small fraction of exp for pickaxes skill when destroying rocks/minerals with the staff.
- You can get elemental magci exp for killing monsters or wild animals.

>** Arctic Staff (Elemental Magic)(Frost Damage)
- Can be crafted after you've killed Modder.

>** Neck Totem (Blood Magic)
- Early game summoning magic weapon.  
- Used to summon Neckzilla to fight alongside you.
- Uses stamina insterd of eitr.
- Max summon and Max star of Neckzilla is determined by your Neck Totems quality level and your Blood Magic Skill Level.
- Upto 4 three Star Neckzilla can be summoned at Max quality level Neck Totem and level 100 blood magic skill.

>** Wolf Totem (Blood Magic)
- Mid-game summoning magic weapon.
- Used to summon Occultist.
- Can only use to summon at level 40 blood magic.
- Upto 2 three star Occultist can be summoned at max level bloodmagic skill.

>** Staff of Healing (Blood Magic)
- Mid-game healing staff.
- Can heal yourself, your summon, and other players if you have Groups installed by smoothbrain. (not tested).

>** Crystal Totem (Blood Magic)
- Mid-game summoning magic weapon.
- Used to summon elemental creatures.

>** Skull Totem (Blood Magic)
- End-game summoning magic weapon.
- Summons armored skeletons.

>** Poison Staff (Elemental Magic) (Poison Damage)
- Mid-game magic staff.

>** Moders Heritage (Elemental Magic)
- End-game boss weapon forge from moders trophy.
- Spawns moders ice shower to the closest enemy so becareful when using this weapon.
- Consumes 100 Eitr and 30 Stamina (Configurable).

>** Yagluths Heritage (Elemental Magic)
- End-game boss weapon forge from yagluths trophy.
- Spawns yagluths meteor shower to the closest enemy so becareful when using this weapon.
- Consumes 100 Eitr and 30 Stamina (Configurable).

<br/>

<details>
<summary><b>PrefabNames</b> (<i>click to expand</i>)</summary>

BMP_ArcticStaff<br/>
BMP_EikthyrsStaff<br/>
BMP_LightningStaff<br/>
BMP_HealStaff<br/>
BMP_NeckTotem<br/>
BMP_SurtlingStaff<br/>
BMP_WolfTotem<br/>
BMP_PoisonStaff<br/>
BMP_CrystalTotem<br/>
BMP_SkullTotem<br/>
BMP_ModersInheritence<br/>
BMP_YagluthsInheritence<br/>
BMP_TrollMagicCape<br/>
BMP_TrollMagicHood<br/>
BMP_CultistCape<br/>
BMP_PolarWolfChest<br/>
BMP_PolarWolfHood<br/>
BMP_PolarWolfLegs<br/>
BMP_RedWizardHelm<br/>
BMP_RedWizardChest<br/>
BMP_RedWizardLegs<br/>
BMP_RedWizardCape<br/>
BMP_MountainSoup<br/>
BMP_MountainStew<br/>
BMP_MushroomJam<br/>
BMP_MushroomPie<br/>
BMP_SautedMeatMushroom<br/>
BMP_DvergrBelt<br/>
BMP_EitrBelt<br/>
BMP_ElementalistBelt<br/>
BMP_HogwartsBelt<br/>
BMP_LightBelt<br/>
BMP_NecromancerBelt<br/>
<br/>
</details>
<br/>

>## ## Changelog
<br/>

v1.6.2
- added config recipes to all items.
- added config options to disable recipes.
- added food stats config.

<details>
<summary><b>Changelog History</b> (<i>click to expand</i>)</summary>
<br/>

v1.6.1
- removed item manager.
- as requested added an improve dead raiser called skull totem that summons armored skeletons and uses two-handed weapons.
- fixed armor shaders, armor textures now properly applies even at the character selection.

v1.5.9
- fixed staffs repair bug.
- adjusted crafting level requirements for some of the staffs.

v1.5.8
- updated to the latest valheim build (217.14) hilder request.
- removed flare effect on lightning staff.
- added missing exp gain on moders and yagluths inheritence.

v1.5.7
- as requested added 4 new armors (recolored fenris armor xD) with eitr regen per piece, with poison resist for the hood, fire resist for the sleeves and frost resist and feather fall for the cape.
- fixed arctic staffs accuracy.
- added launch angle config option for arctic staff.
- fixed armors shaders, they now use vanilla shaders.
- removed incompatible modlist (valheim legends/sage vault).

v1.5.5
- adjusted slime summons scale and make it a little bigger.
- fixed slime summons bug (disappearing/despawning/vanishing)
- added config option for wolf totem level requirements for summoning

v1.5.4
- updated to the latest valheim build (216.9)

v1.5.3
- added possible multiplayer fixes for moders/yagluth heritage.
- improves moders/yagluths heritage targeting system.

v1.5.2
- changed neckzilla and occultist texture to more like white/greyish color so they would look like spirit version of neck and cultist.
- added a boss tier magic weapon called Moders Heritage and Yagluths Heritage, spawns ice/meteor shower to closest enemies so becareful when using this weapons.

v1.4.9
- fixed wrong prefab name on elementalistbelt recipe
(Need to delete \config\blacks7ar.MagicPlugin.cfg for fixed to take effect)
- updated to the latest itemmanager and serversync

v1.4.8
- fixed NRE's when hitting trees/resources with bare hands

v1.4.7
- reduced visual effects of staves
- reduced aoe effect of eikthyrs/lightning staff
- minor bug fixes

v1.4.6
- fixed minor bug when cutting/mining in multiplayer

v1.4.5
- fixed surtling/eikthyrs/lightning staffs tool tier, they can now properly destroy higher tier resources.
- revised staff of healings code, removed group mods dependency, it can now properly heal other players.
- added 6 new magical belts that will help you on your magical journey.

v1.4.3
- minor bug fixes and added possible fixed for healing other players

v1.4.2
- added a no-glow variation of Eikthyr Staff called Lightning Staff (special request of a generous supporter)
- fixed aoe range scaling of arctic staff
- reduced eikthyr staffs light intensity
- updated to the latest valheim and bepinex builds

v1.4.1
- fixed messagehud typo
- fixed staff of healings blood magic exp, you no longer get blood magic exp if your hp is full or no healing is done.
- added posible fixed for healing other players (again not tested, so you should test it and give me feedback if it work or not)

v1.4.0
- rewritten code from scratch
- remove dot aoe damages
- added back summon level scaling (summons level scaled by bloodmagic's level)
- added elemental damages scaling (fire, frost, lightning, poison damages is now scaled by elementalmagic's level)
- added possible fixed for healing other players (not tested), groups mod still needed.
- reworked some staffs models
- reduced/scaled down vfx/smoke effects/light effects
- updated to the latest valheim and bepinex builds


v1.3.4
- fixed compatibility issue with KG's MagicHeim
- fixed status effect bug when wearing polarwolf set

v1.3.3
- fixed arctic staff and ice staff vfx bug when you fire in rapid mode.
- adjusted the minimum accepted values for the summoning cooldowns down to 5secs

v1.3.2
- fixed staff of protection bug.
- removed and reduce some smoke vfx that hinders players vision
- fixed arctic staffs projectile trajectory
- removed level scaling of summoned creatures

v1.3.1
- sorry guys i made a mistake i forgot to copy the correct updated dll >_< please don't cursed me xD

v1.3.0
- added 2 new staffs called Crystal Totem and Poison Staff
- added 4 new summonable elemental creatures
- added toggle option to use both eitr and stamina as magic source
- summoned creatures/tames no longer takes damage from aoe dot's of magical staffs.

v1.2.7
- fixed wolf totems cooldown timer not applying correctly when you summon occultist.

v1.2.6
- Staff of Healing can now heal all tames not just summoned creatures, all monster that are tameables and already tamed can now be healed by Staff of Healing.

v1.2.5
- added debuff capabilities for the staff of healing, it can now remove status effects like frost, smoked, burning, poison, tared, and wet.

v1.2.4
- added paralyze immunity status effect for monsters. when they get hit by eikthyrs staffs aoe and got paralyzed they'll have a chance to get a paralyze immunity for 12secs.
- fixed no eitr warning for staff of healing.

v1.2.3
- fixed healing staffs bug when you dodge and quickly use it there's no vfx/sfx.
- fixed healing staffs bloodmagic skill bug. bloodmagic skill can now gain a small fraction of exp after using staff of healing.

v1.2.2
- Added a fixed to eitr problem with the 2 staffs and 2 totems while using Terraheim. But you still can't change from eitr to stamina white Terraheim is installed.
- Added configuration for the Eikthyrs Staffs static field. Static Field Aoe Lightning Damage, Duration, Radius and Interval are now configurable. If you want to disable the paralyze effect set Static Field Interval to 0.

v1.2.1
- adjusted down lightnings aoe sfx volume

v1.2.0
- reworked Eikthyrs Staff, it'll no longer do massive aoe damage, instead it will create a static field which will paralyze anyone around an area and do 1 lightning damage every 2.5 seconds for 10 seconds.
- added proper cooldown timers for necktotem and wolftotem, you can now see a visual indication.
- tone down the volume of the lightning aoe.
- switch to yml translation, english translation is embedded but you can still make your own just follow the example inside the zip file
- added a new staff called Staff of Healing which will heal you overtime, it will also heal your summons and (other players if you have Groups mod by smoothbrain. not tested) but it will probably hopefully work xD
- added configuration for Heal Overtime amount, Heal Duration, Heal Interval, Heal Range and Heal Cooldown.
- added soft dependency to smoothbrains Groups mod
- renamed all prefabs to be unique to MagicPlugin.
- Adjusted eitr regens of both set effect from 3% to 10%, from 5% to 25%
(NOTE: This new version uses new prefabnames, if you have legendary staffs/armors or max upgrade and dont want them to DISAPPEAR, DO NOT UPDATE!)

v1.1.6
- fixed config live update, changes applies immediately now no need to logout or attack first to take effect
- added summons health and attack damages configuration
- added version checks
- updated to latest valheim assemblies

v1.1.5
- fixed some minor shader issue
- fixed minor conflict with my bowplugin

v1.1.4
- fixed eitr regen of forest magic and arctic buff, it was supposed to be just +3% and +5% but instead valheim sets it to +300% and +500% (thanks to @Attelaus from nexus from noticing this)
- added eitr regen amount configuration for each set effect.
- added full configuration for foods, you can now edit their values

v1.1.3
- fixed compatibility issue with randyknapps jams
- fixed some items and icons
- adjusted frost staffs particle effect

v1.1.2
- fixed compatibility issue with runic pack

v1.1.1
- fixed capes invisible texture thanks to balronds doublesided shader
- added possible fixes for multiplayer/coop (not tested)
- added attack force settings for more damage configuration
- added a new staff called Arctic Staff which deals frost damage
- added immunity to each elemental weapon which counter its aoe effect
(Arctic Staff immunes to frost damage / Eikthyrs Staff immune to lighning damage)
- added 4 new armor called Polarwolf Hood, Polarwolf Tunic, Polarwolf Trouser and Cultist Cape with set effect for midgame which gives cold and freezing resist and 5% eitr regen.
- added 2 new foods called Mountain Soup and Mountain Stew together with Mushroom Pie you'll get a total of 124 eitr which is the prerequisite in using the Wolf Totem.

v1.1.0
- Added 2 new armors with a set effect
- Added 3 new eitr foods which will give you 76 eitr

v1.0.9
- adjusted damage values and attack force of eikthyrs staff to make it less op

v1.0.8
- fixed AOE OnTriggerStay warning

v1.0.7
- fixed summoned creatures, summoned creatures no longer despawn when you logout.
- added possible fix for coop/multiplayer (not tested)

v1.0.6
- fixed eitr/stamina switching should properly work now. need to logout to properly take effect

v1.0.5
- fixed compatibility issue with potionplus

v1.0.4
- fixed NREs when using bow/crossbow
- fixed NREs when using firestaff and icestaff
- added translations. you can now add your own translations
- added option toggle to use either stamina or eitr (takes 1-2 attacks for the change to take effect)

v1.0.3
- fixed aoe ranged scaling. it is now properly scaled according to your elemental magic skill level.
- fixed max crafting station level needed for the upgrades
- added full recipe configuration
- added fire/lightning damage configuration
- added chop/pickaxe damage configuration
- added base aoe range configuration
- added stamina consumption configuration
- added cooldown timer configuration for necktotem and wolftotem
- added lightning staff called Eikthyrs Staff, can be used to destroy rocks/minerals

v1.0.2
- fixed surtling staff aoe hopefully.
- nerf neckzilla's hp a little bit.
- added cooldown timers for neck totem and wolf totem so it wont be used to spam summons.
- added wolf totem a mid game summoning magic weapon.
- added accuracy config.
- balance the levelup chance of neckzilla

v1.0.1
- fixed birch and oak trees tree stump being too hard. surtling staffs quality level is now properly functioning.
- fixed elemental magic and blood magic exp multipliers. they are separate now.
- added a new magic weapon called Neck Totem that can summon a monster to fight alongside you.

v1.0.0
- first release
</details>

